<template>
  <div class="cart-sidebar">
    <v-navigation-drawer v-model="drawer" :width="width" color="white" :class="`elevation-${elevation}`" right fixed>
      <v-card flat>
        <template v-if="$fetchState.pending">
          <div class="text-center mt-10">
            <v-progress-circular :size="64" color="lime" indeterminate></v-progress-circular>
          </div>
        </template>
        <template v-else>
          <v-card-title>
            <span v-text="cartItemsLen"></span>
            <span class="ml-1" v-text="$tc('text.product-total', cartItemsLen)"></span>

            <v-spacer></v-spacer>
            <v-btn text large icon color="light-blue" @click="drawer = false">
              <v-icon>mdi-close</v-icon>
            </v-btn>
          </v-card-title>

          <v-divider></v-divider>

          <v-card-text v-if="products.length">
            <v-list two-line>
              <template v-for="(product, i) in products">
                <v-list-item v-if="product.deleted" :key="`cart-sidebar-product-${product.id}`">
                  <div>
                    <span v-text="$t('text.cart-item-deleted')"></span>
                    <a
                      href="#"
                      @click.prevent="setDeletedState(product.id, false)"
                      v-text="$t('button.undo-delete')"
                    ></a>
                  </div>
                </v-list-item>
                <v-hover v-else :key="`cart-sidebar-product-${product.id}`" v-slot:default="{ hover }">
                  <v-list-item>
                    <v-list-item-avatar>
                      <nuxt-link :to="`${baseUrl}/${product.category}/${product.id}`">
                        <v-img :src="product.images[0].thumbnail"></v-img>
                      </nuxt-link>
                    </v-list-item-avatar>

                    <v-list-item-content>
                      <v-list-item-title class="font-weight-light body-2">
                        <nuxt-link
                          :to="`${baseUrl}/${product.category}/${product.id}`"
                          v-text="product.name"
                        ></nuxt-link>
                      </v-list-item-title>
                      <v-list-item-subtitle>
                        <span class="font-weight-medium black--text">{{ product.price | formattedCost }} ₽</span>
                        <span v-if="cart[i].quantity > 1">x {{ cart[i].quantity }}</span>
                      </v-list-item-subtitle>
                    </v-list-item-content>

                    <v-fab-transition>
                      <v-btn
                        v-show="hover"
                        color="red lighten-2"
                        fab
                        dark
                        small
                        absolute
                        bottom
                        right
                        @click="setDeletedState(product.id, true)"
                      >
                        <v-icon>mdi-close</v-icon>
                      </v-btn>
                    </v-fab-transition>
                  </v-list-item>
                </v-hover>
              </template>
            </v-list>

            <v-divider></v-divider>

            <div class="font-weight-medium black--text mt-4">
              {{ $t('text.total-price') }}: {{ totalPrice | formattedCost }} ₽
            </div>
          </v-card-text>
        </template>
      </v-card>

      <v-card flat>
        <v-card-text>
          <v-btn
            color="orange"
            depressed
            large
            dark
            nuxt
            :to="`${baseUrl}/cart`"
            v-text="$t('button.order-registration')"
          ></v-btn>
        </v-card-text>
      </v-card>
    </v-navigation-drawer>

    <div :class="{ 'cart-sidebar__toggle-btn': true, 'is-scrolled': scrollTop > 200 }">
      <v-slide-y-transition class="trqqqqq">
        <v-btn
          v-if="!drawer"
          v-show="cartItemsLen"
          color="indigo"
          class="text-lowercase body-1 px-8 py-6"
          dark
          rounded
          depressed
          :loading="$fetchState.pending"
          @click="drawer = true"
        >
          <v-icon left>mdi-cart-outline</v-icon>
          <span class="ml-1">{{ cartItemsLen }} {{ $tc('text.product-total', cartItemsLen) }}</span>
          <span class="mx-2">/</span>
          <span>
            <product-price :value="totalPrice"></product-price>
          </span>
        </v-btn>
      </v-slide-y-transition>
    </div>
  </div>
</template>

<script>
export default {
  async fetch() {
    const { cart } = this.$store.state.catalog
    const list = cart.map(item => item.id)

    if (!this.cartItemsLen || !list.length) return false

    try {
      const products = await this.$api('v1').request(`oasis/products?ids=${list.join(',')}&groupby=0`)
      this.products = products.map(item => ({
        ...item,
        get deleted() {
          const cartItem = cart.find(i => i.id === item.product_oasis_id)
          return cartItem.deleted
        },
      }))
    } catch (err) {
      console.error(err)
    }
  },

  data: () => ({
    products: [],
    drawer: false,
    elevation: 20,
    width: 320,
    scrollTop: 0,
  }),

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    cart() {
      return this.$store.state.catalog.cart || []
    },

    cartItemsLen() {
      return this.cart.filter(p => !p.deleted).length || 0
    },

    totalQuantity() {
      return this.cart.reduce((acc, cur) => acc + cur.quantity, 0)
    },

    totalPrice() {
      if (!this.products.length) return 0
      return this.products
        .filter(p => !p.deleted)
        .reduce((acc, cur, i) => acc + parseFloat(cur.price) * this.cart[i].quantity, 0)
    },
  },

  watch: {
    cartItemsLen() {
      this.$fetch()
    },

    totalQuantity(val, oldval) {
      if (val > oldval) {
        this.drawer = true
      }
    },
  },

  fetchOnServer: false,

  methods: {
    setDeletedState(id, deleted) {
      this.$store.commit('catalog/SET_ITEM_DELETED', { id, deleted })
    },
  },
}
</script>

<style lang="scss" scoped>
.cart-sidebar {
  &__toggle-btn {
    position: fixed;
    z-index: 99;
    right: 25px;
    bottom: 25px;
    transition: all 0.3s ease-in-out;

    &.is-scrolled {
      bottom: 55px;
    }

    button {
      background: linear-gradient(135deg, #8711c1 0%, #2472fc 100%);
    }

    .total,
    .price {
      font-family: $numerals-font-family;
      font-size: 1.2rem;
    }

    &::before {
      position: absolute;
      z-index: 0;
      bottom: 0;
      left: 0;
      width: 100%;
      height: 100%;
      background: linear-gradient(135deg, #c1e782 0%, #9b068e 100%);
      border-radius: 40px;
      content: '';
      filter: blur(25px);
      transform: translateY(10px) scale(0.9);
      transition: all 0.3s ease-in-out;
    }

    &:hover {
      button {
        animation: hue-rotation 10s linear 0ms infinite !important;
      }
    }
  }
}
</style>
